unit LabDemo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  LABDATE, ExtCtrls, ComCtrls, Grids, Calendar, StdCtrls;

type
  Tfrm_DateDemo = class(TForm)
    LABDATE1: TLABDATE;
    StatusBar: TStatusBar;
    grp_Base: TGroupBox;
    grp_Incr: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    edt_MM: TEdit;
    edt_DD: TEdit;
    edt_YY: TEdit;
    Label4: TLabel;
    edt_IncMM: TEdit;
    Label5: TLabel;
    edt_IncDD: TEdit;
    Label6: TLabel;
    edt_IncYY: TEdit;
    grp_New: TGroupBox;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    edt_NewMM: TEdit;
    edt_newDD: TEdit;
    edt_NewYY: TEdit;
    Cal1: TCalendar;
    pnl_cal: TPanel;
    btn_New: TButton;
    btn_Inc: TButton;
    btn_Curr: TButton;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    procedure FormActivate(Sender: TObject);
    procedure Cal1Change(Sender: TObject);
    procedure btn_NewClick(Sender: TObject);
    procedure Set_Calendar(Mon, Da, Yr : integer);
    procedure btn_CurrClick(Sender: TObject);
    procedure Show_LabDate;
    procedure btn_IncClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frm_DateDemo: Tfrm_DateDemo;

implementation

{$R *.DFM}
procedure Tfrm_DateDemo.show_LabDate;
begin
  with labdate1 do
    begin
      edt_mm.text := intToStr(BaseMM);
      edt_dd.text := intToStr(BaseDD);
      edt_yy.text := intToStr(BaseYY);
      edt_Incmm.text := intToStr(IncMM);
      edt_Incdd.text := intToStr(IncDD);
      edt_Incyy.text := intToStr(IncYY);
      edt_Newmm.text := intToStr(NewMM);
      edt_Newdd.text := intToStr(NewDD);
      edt_Newyy.text := intToStr(NewYY);
    end; (* with labdate1 *)
end;

procedure Tfrm_DateDemo.Set_Calendar(mon, da, yr : integer);
begin
   with cal1 do
     begin
       month := mon;
       day := da;
       year := yr;
     end;  (* with cal1 *)
   show_labDate;
end;
procedure Tfrm_DateDemo.FormActivate(Sender: TObject);
var
  l_str : string;
begin
  with LabDate1 do
    begin
      with statusBar do
        begin
           panels[0].text := 'Curr Date: ' + IntToStr(BaseMM) + '/';
           panels[0].text := panels[0].text + IntToStr(BaseDD) + '/';
           panels[0].text := panels[0].text + IntToStr(BaseYY);

           panels[1].text := 'Day of week: ' + StrDayOfWeek;

           panels[2].text := 'Month: ' + StrMonth;

           Str(encodedDate:10:0,l_str);
           panels[3].text := 'Delphi encoded date: ' + l_str;

           panels[4].text := 'Julian date: ' + intToStr(JulianDate);
        end;
    end;  (* with labdate *)

  cal1Change(sender);  (* force calendar to change to update panel *)
end;

procedure Tfrm_DateDemo.Cal1Change(Sender: TObject);
begin
  with cal1 do
    begin
      pnl_cal.caption := intToStr(month) + '/' + IntToStr(day) + '/' + IntToStr(year);
    end;  (* with cal1 *)
end;

procedure Tfrm_DateDemo.btn_NewClick(Sender: TObject);
begin
   with LabDate1 do
      begin
        newDD := StrToInt(edt_NewDD.text);
        newMM := StrToInt(edt_NewMM.text);
        newYY := StrToInt(edt_NewYY.text);
        UseNewDate;
        set_Calendar(NewMM,NewDD,NewYY);
      end;  (* with labdate *)
end;

procedure Tfrm_DateDemo.btn_CurrClick(Sender: TObject);
begin
   with labdate1 do
     begin
       useCurrDate;
       set_Calendar(BaseMM,BaseDD,BaseYY);
     end; (* with labdate *)
end;

procedure Tfrm_DateDemo.btn_IncClick(Sender: TObject);
begin
   with labdate1 do
     begin
       IncMM := strToInt(edt_IncMM.text);
       IncDD := strToInt(edt_IncDD.text);
       IncYY := strToInt(edt_IncYY.text);
       ChangeDate;
       Set_Calendar(BaseMM,BaseDD,BaseYY);
     end;  (* with labdate1 *)
end;

end.
